/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.entschaedigung.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ByAuszahlung",
     query="DELETE FROM Entschaedigung obj WHERE obj.auszahlung = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerBeliebigeAuszahlungAndPersondendaten",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung IS NOT NULL AND obj.personendaten = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerBeliebigePersonendatenAndWahl",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung IS NULL AND obj.personendaten IS NOT NULL AND obj.personendaten.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerBeliebigePersonendatenAndWahltermin",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung IS NULL AND obj.personendaten IS NOT NULL AND obj.personendaten.wahltermin = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerKonkreteAuszahlung",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerKonkretePersondendatenAndEntschaedigungStatus",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung IS NULL AND obj.personendaten = ?1 AND obj.status IN(?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.ErstelltFuerKonkretePersonendaten",
     query="SELECT obj FROM Entschaedigung obj WHERE obj.auszahlung IS NULL AND obj.personendaten = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="ENTSCHAEDIGUNG.Wahltermin",
     query="SELECT e FROM Entschaedigung e LEFT JOIN e.auszahlung a LEFT JOIN e.personendaten p WHERE p.wahltermin=?1 OR a.wahltermin=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ENTSCHAEDIGUNG")
// @javax.persistence.IdClass(EntschaedigungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Entschaedigung
extends AbstractEntschaedigung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Entschaedigung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Entschaedigung(Entschaedigung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "entschaedigung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Entschaedigung")
    @javax.persistence.TableGenerator(name = "Entschaedigung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Entschaedigung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EntschaedigungPK pkCache;

  @Override
  public EntschaedigungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EntschaedigungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Entschaedigung> java.util.Map<EntschaedigungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EntschaedigungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Entschaedigung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedAnzahl = false;
          hasChangedBezeichnung = false;
          hasChangedEinzelbetrag = false;
          hasChangedGesamtbetrag = false;
          hasChangedStatus = false;
          hasChangedWaehrungAlsIsoCode = false;
  
      hasChangedAuszahlung = false;
        hasChangedEntschaedigungsart = false;
        hasChangedPersonendaten = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "ANZAHL", nullable = EntschaedigungConstants.ANZAHL_NULLABLE, precision=EntschaedigungConstants.ANZAHL_PRECISION, scale=EntschaedigungConstants.ANZAHL_SCALE)
            
  protected java.lang.Long anzahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedAnzahl = false;

  public boolean hasChangedAnzahl(){
    return hasChangedAnzahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertAnzahl = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenAnzahl;
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.ANZAHL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Long getAnzahl() {
        return anzahl;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.ANZAHL
   *
   * @param anzahl
   */
  @Override   public void setAnzahl(@javax.annotation.Nullable  java.lang.Long anzahl) {

       resetTkCache();
                  java.lang.Long anzahlInternal = anzahl;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.anzahl
      , anzahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedAnzahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("anzahl");
      }


             if (!isSeitLadenVeraendertAnzahl) {
          isSeitLadenVeraendertAnzahl = thisAttributChanged;
         if (isSeitLadenVeraendertAnzahl){
           wertNachLadenAnzahl=this.anzahl;
         }
       }
      

       this.anzahl = anzahlInternal;

         }

        
  @javax.persistence.Column(name = "BESCHREIBUNG", nullable = EntschaedigungConstants.BESCHREIBUNG_NULLABLE, length=EntschaedigungConstants.BESCHREIBUNG_MAX_LENGTH)
        
  protected java.lang.String bezeichnung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBezeichnung = false;

  public boolean hasChangedBezeichnung(){
    return hasChangedBezeichnung;
  }
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.BESCHREIBUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBezeichnung() {
        return bezeichnung;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.BESCHREIBUNG
   *
   * @param bezeichnung
   */
  @Override   public void setBezeichnung(@javax.annotation.Nullable  java.lang.String bezeichnung) {

       resetTkCache();
                  
                          java.lang.String bezeichnungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bezeichnung, EntschaedigungConstants.BESCHREIBUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bezeichnung
      , bezeichnungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBezeichnung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bezeichnung");
      }


      

       this.bezeichnung = bezeichnungInternal;

         }

        
  @javax.persistence.Column(name = "EINZELBETRAG", nullable = EntschaedigungConstants.EINZELBETRAG_NULLABLE, precision=EntschaedigungConstants.EINZELBETRAG_PRECISION, scale=EntschaedigungConstants.EINZELBETRAG_SCALE)
            
  protected java.math.BigDecimal einzelbetrag =  null;

  @javax.persistence.Transient
  protected boolean hasChangedEinzelbetrag = false;

  public boolean hasChangedEinzelbetrag(){
    return hasChangedEinzelbetrag;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertEinzelbetrag = false;
     @javax.persistence.Transient
     private transient java.math.BigDecimal wertNachLadenEinzelbetrag;
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.EINZELBETRAG
   */
  @javax.annotation.Nullable   @Override   public  java.math.BigDecimal getEinzelbetrag() {
        return einzelbetrag;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.EINZELBETRAG
   *
   * @param einzelbetrag
   */
  @Override   public void setEinzelbetrag(@javax.annotation.Nullable  java.math.BigDecimal einzelbetrag) {

       resetTkCache();
                  java.math.BigDecimal einzelbetragInternal = einzelbetrag;
       
                java.math.BigDecimal alterWert = getEinzelbetrag();
         einzelbetragInternal = preProcessEinzelbetrag(einzelbetragInternal);
         preSetEinzelbetrag(alterWert, einzelbetragInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.einzelbetrag
      , einzelbetragInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedEinzelbetrag |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("einzelbetrag");
      }


             if (!isSeitLadenVeraendertEinzelbetrag) {
          isSeitLadenVeraendertEinzelbetrag = thisAttributChanged;
         if (isSeitLadenVeraendertEinzelbetrag){
           wertNachLadenEinzelbetrag=this.einzelbetrag;
         }
       }
      

       this.einzelbetrag = einzelbetragInternal;

                postSetEinzelbetrag(alterWert, einzelbetragInternal);
         }

  
    @Override
    protected java.math.BigDecimal preProcessEinzelbetrag(java.math.BigDecimal neuerWert) {
      return super.preProcessEinzelbetrag(neuerWert);
    }

    @Override
    protected void preSetEinzelbetrag(java.math.BigDecimal alterWert, java.math.BigDecimal neuerWert) {
      super.preSetEinzelbetrag(alterWert, neuerWert);
    }

    @Override
    protected void postSetEinzelbetrag(java.math.BigDecimal alterWert, java.math.BigDecimal neuerWert) {
      super.postSetEinzelbetrag(alterWert, neuerWert);
    }
        
  @javax.persistence.Column(name = "GESAMTBETRAG", nullable = EntschaedigungConstants.GESAMTBETRAG_NULLABLE, precision=EntschaedigungConstants.GESAMTBETRAG_PRECISION, scale=EntschaedigungConstants.GESAMTBETRAG_SCALE)
            
  protected java.math.BigDecimal gesamtbetrag =  null;

  @javax.persistence.Transient
  protected boolean hasChangedGesamtbetrag = false;

  public boolean hasChangedGesamtbetrag(){
    return hasChangedGesamtbetrag;
  }
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.GESAMTBETRAG
   */
  @javax.annotation.Nullable   @Override   public  java.math.BigDecimal getGesamtbetrag() {
        return gesamtbetrag;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.GESAMTBETRAG
   *
   * @param gesamtbetrag
   */
  @Override   public void setGesamtbetrag(@javax.annotation.Nullable  java.math.BigDecimal gesamtbetrag) {

       resetTkCache();
                  java.math.BigDecimal gesamtbetragInternal = gesamtbetrag;
       
                java.math.BigDecimal alterWert = getGesamtbetrag();
         gesamtbetragInternal = preProcessGesamtbetrag(gesamtbetragInternal);
         preSetGesamtbetrag(alterWert, gesamtbetragInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.gesamtbetrag
      , gesamtbetragInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedGesamtbetrag |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("gesamtbetrag");
      }


      

       this.gesamtbetrag = gesamtbetragInternal;

                postSetGesamtbetrag(alterWert, gesamtbetragInternal);
         }

  
    @Override
    protected java.math.BigDecimal preProcessGesamtbetrag(java.math.BigDecimal neuerWert) {
      return super.preProcessGesamtbetrag(neuerWert);
    }

    @Override
    protected void preSetGesamtbetrag(java.math.BigDecimal alterWert, java.math.BigDecimal neuerWert) {
      super.preSetGesamtbetrag(alterWert, neuerWert);
    }

    @Override
    protected void postSetGesamtbetrag(java.math.BigDecimal alterWert, java.math.BigDecimal neuerWert) {
      super.postSetGesamtbetrag(alterWert, neuerWert);
    }
        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = EntschaedigungConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus status =  de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus.VORGESEHEN;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.STATUS
   */
    @Override   public  de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus status) {

       resetTkCache();
                  de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
  @javax.persistence.Column(name = "WAEHRUNG", nullable = EntschaedigungConstants.WAEHRUNG_NULLABLE, length=EntschaedigungConstants.WAEHRUNG_MAX_LENGTH)
        
  protected java.lang.String waehrungAlsIsoCode =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWaehrungAlsIsoCode = false;

  public boolean hasChangedWaehrungAlsIsoCode(){
    return hasChangedWaehrungAlsIsoCode;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWaehrungAlsIsoCode = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenWaehrungAlsIsoCode;
  
  /**
   * 
   *
   * getter for ENTSCHAEDIGUNG.WAEHRUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getWaehrungAlsIsoCode() {
        return waehrungAlsIsoCode;
      }

  /**
   * 
   *
   * setter for ENTSCHAEDIGUNG.WAEHRUNG
   *
   * @param waehrungAlsIsoCode
   */
  @Override   public void setWaehrungAlsIsoCode(@javax.annotation.Nullable  java.lang.String waehrungAlsIsoCode) {

       resetTkCache();
                  
                          java.lang.String waehrungAlsIsoCodeInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(waehrungAlsIsoCode, EntschaedigungConstants.WAEHRUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.waehrungAlsIsoCode
      , waehrungAlsIsoCodeInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWaehrungAlsIsoCode |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("waehrungAlsIsoCode");
      }


             if (!isSeitLadenVeraendertWaehrungAlsIsoCode) {
          isSeitLadenVeraendertWaehrungAlsIsoCode = thisAttributChanged;
         if (isSeitLadenVeraendertWaehrungAlsIsoCode){
           wertNachLadenWaehrungAlsIsoCode=this.waehrungAlsIsoCode;
         }
       }
      

       this.waehrungAlsIsoCode = waehrungAlsIsoCodeInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Auszahlung
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "AUSZAHLUNG_ID", referencedColumnName="AUSZAHLUNG_ID"))
  protected de.ivu.elect.business.entschaedigung.entity.Auszahlung auszahlung;

  /**
   * 
   */
  @Override
  public void setAuszahlung(@javax.annotation.Nullable  de.ivu.elect.business.entschaedigung.entity.Auszahlung auszahlung){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.auszahlung
    , auszahlung);

    attributeChanged |= thisAttributChanged;

    hasChangedAuszahlung |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("auszahlung");
    }

    this.auszahlung = auszahlung;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.entschaedigung.entity.Auszahlung getAuszahlung(){
    return this.auszahlung;
  }

  @javax.persistence.Transient
  protected boolean hasChangedAuszahlung = false;

  public boolean hasChangedAuszahlung(){
    return hasChangedAuszahlung;
  }

  /**
   * Beziehung (unidirektional) zu Entschaedigungsart
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "ENTSCHAEDIGUNGSART_ID", referencedColumnName="ENTSCHAEDIGUNGSART_ID"))
  protected de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart entschaedigungsart;

  /**
   * 
   */
  @Override
  public void setEntschaedigungsart(@javax.annotation.Nullable  de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart entschaedigungsart){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.entschaedigungsart
    , entschaedigungsart);

    attributeChanged |= thisAttributChanged;

    hasChangedEntschaedigungsart |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("entschaedigungsart");
    }

    this.entschaedigungsart = entschaedigungsart;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.entschaedigung.entity.Entschaedigungsart getEntschaedigungsart(){
    return this.entschaedigungsart;
  }

  @javax.persistence.Transient
  protected boolean hasChangedEntschaedigungsart = false;

  public boolean hasChangedEntschaedigungsart(){
    return hasChangedEntschaedigungsart;
  }

  /**
   * Beziehung (unidirektional) zu Personendaten
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "PERSONENDATEN_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.person.entity.Personendaten personendaten;

  /**
   * 
   */
  @Override
  public void setPersonendaten( de.ivu.elect.business.person.entity.Personendaten personendaten){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.personendaten
    , personendaten);

    attributeChanged |= thisAttributChanged;

    hasChangedPersonendaten |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("personendaten");
    }

    this.personendaten = personendaten;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.person.entity.Personendaten getPersonendaten(){
    return this.personendaten;
  }

  @javax.persistence.Transient
  protected boolean hasChangedPersonendaten = false;

  public boolean hasChangedPersonendaten(){
    return hasChangedPersonendaten;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Entschaedigung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Entschaedigung other){
                             other.anzahl = this.anzahl;
                                other.bezeichnung = this.bezeichnung;
                                other.einzelbetrag = this.einzelbetrag;
                                other.gesamtbetrag = this.gesamtbetrag;
                                other.status = this.status;
                                other.waehrungAlsIsoCode = this.waehrungAlsIsoCode;
           
  other.setAuszahlung(this.getAuszahlung());
  other.setEntschaedigungsart(this.getEntschaedigungsart());
  other.setPersonendaten(this.getPersonendaten());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Entschaedigung.class)){
        copyEntityAttributesUsingSetter((Entschaedigung) other.castTo(Entschaedigung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Entschaedigung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Entschaedigung other){
               other.setAnzahl(this.anzahl);
                  other.setBezeichnung(this.bezeichnung);
                  other.setEinzelbetrag(this.einzelbetrag);
                  other.setGesamtbetrag(this.gesamtbetrag);
                  other.setStatus(this.status);
                  other.setWaehrungAlsIsoCode(this.waehrungAlsIsoCode);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Entschaedigung other){
                       if (hasChangedAnzahl) {
        other.setAnzahl(this.anzahl);
      }
                             if (hasChangedBezeichnung) {
        other.setBezeichnung(this.bezeichnung);
      }
                             if (hasChangedEinzelbetrag) {
        other.setEinzelbetrag(this.einzelbetrag);
      }
                             if (hasChangedGesamtbetrag) {
        other.setGesamtbetrag(this.gesamtbetrag);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedWaehrungAlsIsoCode) {
        other.setWaehrungAlsIsoCode(this.waehrungAlsIsoCode);
      }
             }





    @javax.persistence.Transient
    private transient EntschaedigungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EntschaedigungTK getEntschaedigungTK(){
    if (tkCache==null) {
    tkCache = new EntschaedigungTK(

  (getAuszahlung() == null) ? null : getAuszahlung().getAuszahlungTK()
,   (getEntschaedigungsart() == null) ? null : getEntschaedigungsart().getEntschaedigungsartTK()
,   (getPersonendaten() == null) ? null : getPersonendaten().getPersonendatenTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEntschaedigungTK();
    }

  @Override
  public EntschaedigungUK getUk(){
    return getEntschaedigungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Entschaedigung.class;
  }

public EntschaedigungUK getEntschaedigungUK(){

   return  new EntschaedigungUK(



  );
}

  @javax.persistence.Transient
  private transient EntschaedigungProperties properties;

  public EntschaedigungProperties getProperties(){
    if (properties == null) {
      properties = new EntschaedigungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EntschaedigungProperties getEntschaedigungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EntschaedigungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(EntschaedigungConstants.MESSAGE_KEY_ANZAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EntschaedigungConstants.MESSAGE_KEY_ANZAHL_EINZAHL);

        anzahl =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

                    
      if (werteVorher.containsKey(EntschaedigungConstants.MESSAGE_KEY_EINZELBETRAG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EntschaedigungConstants.MESSAGE_KEY_EINZELBETRAG_EINZAHL);

        einzelbetrag =
                        vorher.getAttributTyp().getValueAsBigDecimal(vorher.getWertVorher());
                  }

                    
      if (werteVorher.containsKey(EntschaedigungConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EntschaedigungConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.entschaedigung.entity.EntschaedigungStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(EntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(EntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL);

        waehrungAlsIsoCode =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertAnzahl) {
      result.put(EntschaedigungConstants.MESSAGE_KEY_ANZAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenAnzahl , anzahl));
    }
                                                if (isSeitLadenVeraendertEinzelbetrag) {
      result.put(EntschaedigungConstants.MESSAGE_KEY_EINZELBETRAG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.BIG_DECIMAL
                            , wertNachLadenEinzelbetrag , einzelbetrag));
    }
                                                if (isSeitLadenVeraendertStatus) {
      result.put(EntschaedigungConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertWaehrungAlsIsoCode) {
      result.put(EntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenWaehrungAlsIsoCode , waehrungAlsIsoCode));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertAnzahl = false;
      wertNachLadenAnzahl = null;
                                          isSeitLadenVeraendertEinzelbetrag = false;
      wertNachLadenEinzelbetrag = null;
                                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertWaehrungAlsIsoCode = false;
      wertNachLadenWaehrungAlsIsoCode = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "ENTSCHAEDIGUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Entschaedigung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EntschaedigungConstants.ANZAHL_MAX_VALUE, EntschaedigungConstants.ANZAHL_MIN_VALUE, anzahl, this, EntschaedigungConstants.MESSAGE_KEY_ANZAHL_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EntschaedigungConstants.BESCHREIBUNG_MAX_LENGTH ,  bezeichnung, this, EntschaedigungConstants.MESSAGE_KEY_BESCHREIBUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EntschaedigungConstants.EINZELBETRAG_MAX_VALUE, EntschaedigungConstants.EINZELBETRAG_MIN_VALUE, einzelbetrag, this, EntschaedigungConstants.MESSAGE_KEY_EINZELBETRAG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(EntschaedigungConstants.GESAMTBETRAG_MAX_VALUE, EntschaedigungConstants.GESAMTBETRAG_MIN_VALUE, gesamtbetrag, this, EntschaedigungConstants.MESSAGE_KEY_GESAMTBETRAG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, EntschaedigungConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EntschaedigungConstants.WAEHRUNG_MAX_LENGTH ,  waehrungAlsIsoCode, this, EntschaedigungConstants.MESSAGE_KEY_WAEHRUNG_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
